/*******************************************************************************
 * FoxWeaponModObjectBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeaponModObjectBase extends Object
    abstract
    native(Weapon)
    config(Weapon);

var(Mesh) protected export editinline FoxFirstPersonSkeletalMeshComponent FPMesh;
var(Mesh) protected export editinline MeshComponent TPMesh;
var config FoxPawnModInfo PawnModifiers;
var config FoxWeaponModInfo WeaponModifiers;
var const config int UnlockID;
var const config int ParentID;
var const localized string FriendlyName;
var const localized string FriendlyDesc;
var const localized string FriendlyTag;
var config string ImageIconRef;
var config string AdditionalIconRef;
var const localized string FriendlyToolTip;
var bool bDLC;
var config string DescriptorName;
var byte DataProviderIndex;
var const array<MaterialInstanceConstant> FPSpawnFXStageOne;
var const array<MaterialInstanceConstant> FPSpawnFXStageTwo;
var const array<MaterialInstanceConstant> TPSpawnFXStageOne;
var const array<MaterialInstanceConstant> TPSpawnFXStageTwo;
var config Rotator PreviewRotation;
var const config float TightAimRecoilTranslationModifier;
var const config float TightAimRecoilRotationModifier;
var array<MaterialInstanceConstant> FPCamoMICs;
var array<MaterialInstanceConstant> TPCamoMICs;
var config array<config string> WhiteRecievers;

// Export UFoxWeaponModObjectBase::execSetDepthPriorityGroup(FFrame&, void* const)
native simulated function SetDepthPriorityGroup(Engine.Scene.ESceneDepthPriorityGroup NewDepthPriorityGroup);

function MeshComponent GetMeshComponent(const bool bFirstPerson)
{
    // End:0x1A
    if(bFirstPerson)
    {
        return FPMesh;
    }
    // End:0x24
    else
    {
        return TPMesh;
    }
    //return ReturnValue;    
}

function FoxFirstPersonSkeletalMeshComponent GetFPMeshComp()
{
    return FPMesh;
    //return ReturnValue;    
}

function StaticMeshComponent GetStaticTPMeshComp()
{
    return StaticMeshComponent(TPMesh);
    //return ReturnValue;    
}

function SkeletalMeshComponent GetSkeletalTPMeshComp()
{
    return SkeletalMeshComponent(TPMesh);
    //return ReturnValue;    
}

static function MeshComponent GetDefaultTPMesh()
{
    return default.TPMesh;
    //return ReturnValue;    
}

static function SkeletalMeshComponent GetDefaultFPMesh()
{
    return default.FPMesh;
    //return ReturnValue;    
}

static function bool HasMesh(const bool bFirstPerson)
{
    // End:0x32
    if(bFirstPerson)
    {
        return default.FPMesh.SkeletalMesh != none;
    }
    // End:0xBB
    else
    {
        // End:0x78
        if(SkeletalMeshComponent(default.TPMesh) != none)
        {
            return SkeletalMeshComponent(default.TPMesh).SkeletalMesh != none;
        }
        // End:0xBB
        else
        {
            // End:0xBB
            if(StaticMeshComponent(default.TPMesh) != none)
            {
                return StaticMeshComponent(default.TPMesh).StaticMesh != none;
            }
        }
    }
    return false;
    //return ReturnValue;    
}

function SetVisibility(const bool bFPVisible, const bool bTPVisible)
{
    // End:0x3A
    if(FPMesh != none)
    {
        FPMesh.SetHidden(!bFPVisible);
    }
    // End:0x74
    if(TPMesh != none)
    {
        TPMesh.SetHidden(!bTPVisible);
    }
    //return;    
}

function SetSpawnEffectStage(const int stage, optional LinearColor SpawnInColor)
{
    local int I;

    // End:0x1A1
    if(FPMesh != none)
    {
        I = 0;
        J0x1B:
        // End:0x1A1 [Loop If]
        if(I < FPMesh.GetNumElements())
        {
            // End:0xD0
            if(stage == 0)
            {
                FPMesh.SetMaterial(I, FPSpawnFXStageOne[I]);
                FPSpawnFXStageOne[I].SetVectorParameterValue('SpawnColor', SpawnInColor);
            }
            // End:0x193
            else
            {
                // End:0x158
                if(stage == 1)
                {
                    FPMesh.SetMaterial(I, FPSpawnFXStageTwo[I]);
                    FPSpawnFXStageTwo[I].SetVectorParameterValue('SpawnColor', SpawnInColor);
                }
                // End:0x193
                else
                {
                    FPMesh.SetMaterial(I, FPCamoMICs[I]);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x1B;
        }
    }
    // End:0x341
    if(TPMesh != none)
    {
        I = 0;
        J0x1BB:
        // End:0x341 [Loop If]
        if(I < TPMesh.GetNumElements())
        {
            // End:0x270
            if(stage == 0)
            {
                TPMesh.SetMaterial(I, TPSpawnFXStageOne[I]);
                TPSpawnFXStageOne[I].SetVectorParameterValue('SpawnColor', SpawnInColor);
            }
            // End:0x333
            else
            {
                // End:0x2F8
                if(stage == 1)
                {
                    TPMesh.SetMaterial(I, TPSpawnFXStageTwo[I]);
                    TPSpawnFXStageTwo[I].SetVectorParameterValue('SpawnColor', SpawnInColor);
                }
                // End:0x333
                else
                {
                    TPMesh.SetMaterial(I, TPCamoMICs[I]);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x1BB;
        }
    }
    //return;    
}

function UpdateSpawnEffectMaterials(const name ParamName, const float Value, const int stage)
{
    local int I;

    // End:0xCB
    if(FPMesh != none)
    {
        I = 0;
        J0x1A:
        // End:0xC8 [Loop If]
        if(I < FPSpawnFXStageOne.Length)
        {
            // End:0x7F
            if(stage == 0)
            {
                FPSpawnFXStageOne[I].SetScalarParameterValue(ParamName, Value);
            }
            // End:0xBA
            else
            {
                FPSpawnFXStageTwo[I].SetScalarParameterValue(ParamName, Value);
            }
            ++ I;
            // [Loop Continue]
            goto J0x1A;
        }
    }
    // End:0x193
    else
    {
        // End:0x193
        if(TPMesh != none)
        {
            I = 0;
            J0xE5:
            // End:0x193 [Loop If]
            if(I < TPSpawnFXStageOne.Length)
            {
                // End:0x14A
                if(stage == 0)
                {
                    TPSpawnFXStageOne[I].SetScalarParameterValue(ParamName, Value);
                }
                // End:0x185
                else
                {
                    TPSpawnFXStageTwo[I].SetScalarParameterValue(ParamName, Value);
                }
                ++ I;
                // [Loop Continue]
                goto J0xE5;
            }
        }
    }
    //return;    
}

function SetupWeaponCamo(int CamoIndex)
{
    local int I, NumTiles;
    local Texture CamoTexture;
    local float MetallicScalar;
    local bool bUseBaseColor;
    local LinearColor BaseColor;
    local float SpecularInterp;

    // End:0x13E
    if((CamoIndex != 255) && CamoIndex != -1)
    {
        MetallicScalar = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[CamoIndex].MetallicInterp;
        bUseBaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[CamoIndex].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[CamoIndex].BaseColor;
        SpecularInterp = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[CamoIndex].SpecularInterp;
    }
    // End:0x234
    else
    {
        MetallicScalar = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].MetallicInterp;
        bUseBaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].bUseBaseColor;
        BaseColor = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].BaseColor;
        SpecularInterp = class'FoxUnlockInfo'.default.WeaponCamoUnlocks[0].SpecularInterp;
    }
    class'FoxUnlockInfo'.static.GetWeaponCamoTexture(CamoTexture, NumTiles, CamoIndex);
    FPCamoMICs.Length = 0;
    TPCamoMICs.Length = 0;
    // End:0x6D7
    if(FPMesh != none)
    {
        I = 0;
        J0x2A0:
        // End:0x531 [Loop If]
        if(I < FPMesh.GetNumElements())
        {
            FPCamoMICs.AddItem(FPMesh.CreateAndSetMaterialInstanceConstant(I));
            FPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseSpecularParamName, SpecularInterp);
            FPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            FPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0x472
            if(bUseBaseColor || MetallicScalar > float(0))
            {
                FPCamoMICs[I].SetVectorParameterValue(class'FoxWeapon'.default.CamoBaseColorParamName, BaseColor);
            }
            // End:0x4D1
            if(CamoTexture != none)
            {
                FPCamoMICs[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            }
            FPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0x2A0;
        }
        I = 0;
        J0x53C:
        // End:0x604 [Loop If]
        if(I < FPSpawnFXStageOne.Length)
        {
            FPSpawnFXStageOne[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            FPSpawnFXStageOne[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0x53C;
        }
        I = 0;
        J0x60F:
        // End:0x6D7 [Loop If]
        if(I < FPSpawnFXStageTwo.Length)
        {
            FPSpawnFXStageTwo[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            FPSpawnFXStageTwo[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0x60F;
        }
    }
    // End:0xB28
    if(TPMesh != none)
    {
        I = 0;
        J0x6F1:
        // End:0x982 [Loop If]
        if(I < TPMesh.GetNumElements())
        {
            TPCamoMICs.AddItem(TPMesh.CreateAndSetMaterialInstanceConstant(I));
            TPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseSpecularParamName, SpecularInterp);
            TPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseBaseColorParamName, ((bUseBaseColor) ? 1.0 : 0.0));
            TPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoUseMetallicParamName, MetallicScalar);
            // End:0x8C3
            if(bUseBaseColor || MetallicScalar > float(0))
            {
                TPCamoMICs[I].SetVectorParameterValue(class'FoxWeapon'.default.CamoBaseColorParamName, BaseColor);
            }
            // End:0x922
            if(CamoTexture != none)
            {
                TPCamoMICs[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            }
            TPCamoMICs[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0x6F1;
        }
        I = 0;
        J0x98D:
        // End:0xA55 [Loop If]
        if(I < TPSpawnFXStageOne.Length)
        {
            TPSpawnFXStageOne[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            TPSpawnFXStageOne[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0x98D;
        }
        I = 0;
        J0xA60:
        // End:0xB28 [Loop If]
        if(I < TPSpawnFXStageTwo.Length)
        {
            TPSpawnFXStageTwo[I].SetTextureParameterValue(class'FoxWeapon'.default.CamoSwapParamName, CamoTexture);
            TPSpawnFXStageTwo[I].SetScalarParameterValue(class'FoxWeapon'.default.CamoTileParamName, float(NumTiles));
            ++ I;
            // [Loop Continue]
            goto J0xA60;
        }
    }
    //return;    
}

simulated function ToggleHRVEffects(MaterialInterface HRVMaterial)
{
    local int I;

    // End:0x41
    if(class'WorldInfo'.static.GetWorldInfo().NetMode == NM_DedicatedServer)
    {
        return;
    }
    // End:0x15F
    if(HRVMaterial != none)
    {
        // End:0xD6
        if(FPMesh != none)
        {
            I = 0;
            J0x6A:
            // End:0xD6 [Loop If]
            if(I < FPMesh.GetNumElements())
            {
                FPMesh.SetMaterial(I, HRVMaterial);
                ++ I;
                // [Loop Continue]
                goto J0x6A;
            }
        }
        // End:0x15C
        if(TPMesh != none)
        {
            I = 0;
            J0xF0:
            // End:0x15C [Loop If]
            if(I < TPMesh.GetNumElements())
            {
                TPMesh.SetMaterial(I, HRVMaterial);
                ++ I;
                // [Loop Continue]
                goto J0xF0;
            }
        }
    }
    // End:0x30F
    else
    {
        // End:0x237
        if(FPMesh != none)
        {
            // End:0x19C
            if(FPMesh.GetNumElements() != FPCamoMICs.Length)
            {
            }
            I = 0;
            J0x1A7:
            // End:0x237 [Loop If]
            if((I < FPMesh.GetNumElements()) && I < FPCamoMICs.Length)
            {
                FPMesh.SetMaterial(I, FPCamoMICs[I]);
                ++ I;
                // [Loop Continue]
                goto J0x1A7;
            }
        }
        // End:0x30F
        if(TPMesh != none)
        {
            // End:0x274
            if(TPMesh.GetNumElements() != TPCamoMICs.Length)
            {
            }
            I = 0;
            J0x27F:
            // End:0x30F [Loop If]
            if((I < TPMesh.GetNumElements()) && I < TPCamoMICs.Length)
            {
                TPMesh.SetMaterial(I, TPCamoMICs[I]);
                ++ I;
                // [Loop Continue]
                goto J0x27F;
            }
        }
    }
    //return;    
}

static simulated function bool IsValidForWeapon(class<FoxWeapon> WeaponClass, optional bool bMustOwn)
{
    local string ClassString;
    local int I;
    local FoxItemCacheInventory InventoryCache;
    local InventoryMetaData InventoryItem;
    local FoxTypes.EPurchaseState PurchaseState;

    ClassString = string(WeaponClass.Name);
    I = 0;
    J0x36:
    // End:0x129 [Loop If]
    if(I < default.WhiteRecievers.Length)
    {
        // End:0x11B
        if(ClassString ~= default.WhiteRecievers[I])
        {
            // End:0x119
            if(bMustOwn && class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache))
            {
                return InventoryCache.GetCachedItemWithBestPurchaseState(InventoryItem, default.UnlockID, PurchaseState, 0, WeaponClass.default.UnlockID) && PurchaseState >= 3;
            }
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x36;
    }
    return false;
    //return ReturnValue;    
}

simulated function bool BuildFromDataProvider(FoxDataProvider_ModBase ModBase)
{
    // End:0x29E
    if(ModBase != none)
    {
        // End:0x8F
        if(ModBase.FPMesh != "")
        {
            FPMesh.SetSkeletalMesh(SkeletalMesh(DynamicLoadObject(ModBase.FPMesh, class'SkeletalMesh')));
        }
        // End:0x1AF
        if(ModBase.TPMesh != "")
        {
            // End:0x133
            if(SkeletalMeshComponent(TPMesh) != none)
            {
                SkeletalMeshComponent(TPMesh).SetSkeletalMesh(SkeletalMesh(DynamicLoadObject(ModBase.TPMesh, class'SkeletalMesh')));
            }
            // End:0x1AF
            else
            {
                // End:0x1AF
                if(StaticMeshComponent(TPMesh) != none)
                {
                    StaticMeshComponent(TPMesh).SetStaticMesh(StaticMesh(DynamicLoadObject(ModBase.TPMesh, class'StaticMesh')));
                }
            }
        }
        PawnModifiers = ModBase.PawnModifiers;
        WeaponModifiers = ModBase.WeaponModifiers;
        ImageIconRef = ModBase.ImageIconRef;
        AdditionalIconRef = ModBase.AdditionalIconRef;
        // End:0x29C
        if(ModBase.WhiteRecievers.Length > 0)
        {
            WhiteRecievers = ModBase.WhiteRecievers;
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

defaultproperties
{
    begin object name=NewFPMesh class=FoxFirstPersonSkeletalMeshComponent
        bForceRefpose=1
        bNoSkeletonUpdate=true
        ReplacementPrimitive=none
        bIgnoreOwnerHidden=true
        TickGroup=ETickingGroup.TG_DuringAsyncWork
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeaponModObjectBase.NewFPMesh'
    FPMesh=NewFPMesh
    PawnModifiers=(SwitchWeaponSpeed=0,MeleeRange=0,Health=0,HealthRecharge=0,MovementSpeed=0,Stamina=0,HRVDuration=0,HRVRechargeRate=0,GearSlots=0,bCalculated=false,HelmetDamageReduction=0,BodyDamageReduction=0,LegsDamageReduction=0,SprintMultiplier=1.0,ToxicProtection=0,PermanentHealthProtection=0,IncendiaryProtection=0,ExplosiveProtection=0,ElectroProtection=0,MeleeProtection=0,InfraredProtection=0)
    DescriptorName="UNNAMEDMOD"
    TightAimRecoilTranslationModifier=1.0
    TightAimRecoilRotationModifier=1.0
    WhiteRecievers(0)="FoxWeapon_SMG"
    WhiteRecievers(1)="FoxWeapon_AssaultRifle"
    WhiteRecievers(2)="FoxWeapon_SniperRifle"
    WhiteRecievers(3)="FoxWeapon_SMG"
    WhiteRecievers(4)="FoxWeapon_BKT"
    WhiteRecievers(5)="FoxWeapon_Bullpup"
    WhiteRecievers(6)="FoxWeapon_BASniper"
    WhiteRecievers(7)="FoxWeapon_9mmPistol"
    WhiteRecievers(8)="FoxWeapon_45Pistol"
    WhiteRecievers(9)="FoxWeapon_AutoPistol"
    WhiteRecievers(10)="FoxWeapon_Revolver"
    WhiteRecievers(11)="FoxWeapon_MachinePistol"
    WhiteRecievers(12)="FoxWeapon_Shotgun"
    WhiteRecievers(13)="FoxWeapon_Revolver"
    WhiteRecievers(14)="FoxWeapon_AR2"
    WhiteRecievers(15)="FoxWeapon_RBKT"
    WhiteRecievers(16)="FoxWeapon_SMG2"
    WhiteRecievers(17)="FoxWeapon_SMGi"
    WhiteRecievers(18)="FoxWeapon_DartGun"
    WhiteRecievers(19)="FoxWeapon_AutoShotgun"
    WhiteRecievers(20)="FoxWeapon_HeavySniper"
    WhiteRecievers(21)="FoxWeapon_Bullpup2"
    WhiteRecievers(22)="FoxWeapon_M4"
    WhiteRecievers(23)="FoxWeapon_AK47"
    WhiteRecievers(24)="FoxWeapon_AR3"
    WhiteRecievers(25)="FoxWeapon_SniperRifle2"
    WhiteRecievers(26)="FoxWeapon_Gold9mmPistol"
    WhiteRecievers(27)="FoxWeapon_GoldAssaultRifle"
}